unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  IColor=interface
    ['{74867740-7C9D-11D2-AC75-00605207DE1D}']
    procedure SetColor(C:TColor);
  end;
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

TMyLabel=class(TLabel,IColor)
 procedure SetColor(C:TColor);
end;

TMyEdit=class(TEdit,IColor)
 procedure SetColor(C:TColor);
end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{TMyLabel}
procedure TMyLabel.SetColor(C:TColor);
begin
  Color:=C;
end;

{TMyEdit}
procedure TMyEdit.SetColor(C:TColor);
begin
  Color:=C;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with TMyLabel.Create(Self) do
      begin
        Parent:=Self;
        Left:=5;
        Top:=5;
        Width:=100;
        Height:=25;
        Caption:='Label';
      end;
  with TMyEdit.Create(Self) do
      begin
        Parent:=Self;
        Left:=5;
        Top:=45;
        Width:=100;
        Height:=25;
        Text:='Edit';
      end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var I:Integer;
    IC:IColor;
begin
  for I:=0 to ComponentCount-1 do
     begin
       Components[I].GetInterface(IColor,IC);
       if Assigned(IC) then IC.SetColor(clGreen);
     end;
end;

end.
